from launchpadlib.launchpad import Launchpad, EDGE_SERVICE_ROOT

from django.conf import settings

import os

def lp_login(lp_instance=EDGE_SERVICE_ROOT):
    """
    Return a logged in Launchpad object. 
    """

    cachedir = os.path.join(settings.PROJECT_PATH, 'lp_data/cache')
    client_ident = getattr(settings, 'LP_PROJECT_NAME', "Harvest")
    try:
        launchpad = Launchpad.login_anonymously(client_ident, lp_instance, cachedir)
    except:
        try:
            # Support for launchpadlib pre 1.5.4.
            launchpad = Launchpad.login(client_ident, "", "", lp_instance, cachedir)
        except:
            # Launchpad might be offline.
            return None
    return launchpad

def get_packagesets(lp):
    """
    Get list of packagesets for current development release of Ubuntu.
    """
    current_series = lp.distributions['ubuntu'].current_series
    packagesets = filter(lambda a: a.distroseries == current_series, lp.packagesets)
    return packagesets
