# Adds an 'X-Django-Request-Time' HTTP response header
# that times how long django spent processing the request.
# From <http://djangosnippets.org/snippets/797/>

from time import time

class TimerMiddleware(object):
    def process_request(self, request):
        request._tm_start_time = time()
    
    def process_response(self, request, response):
        if not hasattr(request, "_tm_start_time"):
            return
        
        total_time = time() - request._tm_start_time
        
        response['X-Django-Request-Time'] = '%fs' % total_time
        
        return response
