LIST_BRANCH_URL = "lp:harvest-data"

import csv
import os

def read_entries(url, last_updated):
    import time
    import datetime
    import urllib2
    try:
        sock = urllib2.urlopen(url)
    except:
        return [None, None]

    timestamp_lm = None
    if sock.info()["Last-Modified"]:
        lm_string = sock.info()["Last-Modified"]
        if lm_string:
            timestamp_lm = time.mktime(time.strptime(lm_string, 
                                                     "%a, %d %b %Y %H:%M:%S GMT"))
            datetime_lm = datetime.datetime.utcfromtimestamp(timestamp_lm)
    if last_updated and datetime_lm and datetime_lm <= last_updated:
        sock.close()
        return [None,None]

    if url.endswith(".csv.gz"):
        import StringIO
        import gzip
        data = gzip.GzipFile(fileobj=StringIO.StringIO(sock.read())).readlines()
    else:
        data = sock.readlines()
    lines = filter(lambda a: a.strip()!="", data)
    sock.close()
    return ([map(unicode, [a for a in l]) for l in csv.reader(lines)], datetime_lm)

def unify_list_entry(entry):
    for e in entry:
        e = unicode(e.strip())
    # only contains url and short description
    if len(entry) == 2:
        entry.extend([None])
    return entry

def read_lists(list_dir):
    list_file = os.path.join(list_dir, "opportunities")
    if not os.path.exists(list_file):
        return []
    lines = open(list_file).readlines()
    
    # comment out empty entries, or entries that were commented out
    lines = filter(lambda b: b.strip() != "" and not b.startswith("#"), lines)
    
    csv_entries = [l for l in csv.reader(lines)]
    entries = map(unify_list_entry, csv_entries)
    return entries


def pull_lists(data_dir):
    list_dir = os.path.join(data_dir, "lists")
    if not os.path.exists(list_dir):
        os.system("cd %s; bzr checkout %s lists -q" % (data_dir, LIST_BRANCH_URL))
    else:
        os.system("cd %s; bzr update -q" % list_dir)
    return list_dir
