def update_url_with_parameters(request, new_parameters, url=None):
    """
    Returns a URL (the current one by default) with some new querystring
    parameters, based on the current querystring and the given
    dictionary of parameters. The dictionary can contain list values as
    well as strings and integers. 
    @param request: the current HttpRequest object
    @param new_parameters: a dictionary of new parameters
    @param url: a url to use instead of the current one
    """
    if url == None: url = request.path
    querydict = request.GET.copy()
    for k in new_parameters:
        v = new_parameters[k]
        if isinstance(v,list):
            querydict.setlist(k, v)
        else:
            querydict[k] = v
    return "%s?%s" % ( url, querydict.urlencode() )

