import email
import os

def get_harvest_version(version_file, debug):
    """
    return the bzr revision number and version of Harvest
    """

    if not os.path.exists(version_file):
        return "version unknown"

    f = email.message_from_file(open(version_file))
    version = f["version"]
    bzr_revno = f["revno"]
    
    if debug:
        try:
            from bzrlib.branch import Branch
            branch = Branch.open_containing('.')[0]
            bzr_revno = branch.revno()
        except:
            pass

    return "version %s (r%s)" % (version, bzr_revno)


def get_harvest_version_name(version_file, debug):
    """
    return a short string describing the version of harvest
    """
    
    version_str = ""
    
    if debug:
        try:
            from bzrlib.branch import Branch
            branch = Branch.open_containing('.')[0]
            version_str = "Revision %s" % branch.revno()
        except:
            pass
    elif os.path.exists(version_file):
        f = email.message_from_file(open(version_file))
        if "versionname" in f:
            version_str = f["versionname"]
    
    return version_str
