from django.http import HttpResponseRedirect
from django.shortcuts import render_to_response
from django.template import RequestContext
from django.contrib.auth import logout
from django.contrib.auth.models import User

def index(request):
    from opportunities.models import SourcePackage, OpportunityList, Opportunity, Note
    context = { 
        'pageSection': 'home', 
        'users': User.objects.count(),
        'sourcepackages': SourcePackage.objects.count(),
        'opportunitylists': OpportunityList.objects.count(),
        'opportunities': Opportunity.objects.count(),
        'notes': Note.objects.count(),
    }
    return render_to_response('index.html', context,
                              context_instance=RequestContext(request))

def doc(request):
    return render_to_response('doc.html', {}, context_instance=RequestContext(request))

def site_logout(request):
    logout(request)
    return HttpResponseRedirect('/')

