"""
Here, we define a very abstract filtering system.
This system is entirely decoupled from presentation. A filter is simply a query
operation intended for a particular type of model, which can be configured and
turned on / off via structured input.

There are, of course, some rules: different types of filters can be added,
some of which store extra information (like a line of text that the user can
input), and filters can be grouped like radio buttons where only one filter
in a group can be selected.

The included classes provide most important features for free, but to be of
any use they need to be extended to fit the intended application. For example,
the get_query class is unimplemented; it should return a Q object that does
the work of selecting whatever the filter is intended to select.

Groups of filters in no way refer to how they get placed in a page, or how
they are interacted with. We leave that entirely up to templates. It is also
something else's job to figure out how to draw filters, and how to form the
links they talk to us with.

All This Does is filter things.
"""
